--- metrics.html	2014-11-24 18:28:03.402786654 +0000
+++ metrics-edit.html	2014-11-24 18:44:04.250735164 +0000
@@ -11,34 +11,34 @@
 
 <h1>Glossary</h1>
 
-<a name="advertised-bandwidth"></a><p><b><a href="#advertised-bandwidth">advertised bandwidth:</a></b> traffic volume in both incoming and outgoing direction that a <a href="#relay">relay</a> is willing to sustain, as configured by the operator, and that the relay reports as being capable to handle, as observed from recent data transfers.
+<a name="advertised-bandwidth"></a><p><b><a href="#advertised-bandwidth">advertised bandwidth:</a></b> the volume of traffic, both incoming and outgoing, that a <a href="#relay">relay</a> is willing to sustain, as configured by the operator and observed from recent data transfers. This value is self-reported and may not correspond to observations by the <a href="#directory-authority">directory authorities</a>.
 <br><i>--is it clear enough that advertised bandwidth refers to both incoming and outgoing bytes at the same time?
 <br>--is it clear enough that advertised bandwidth is self-reported by relays and not verified by directory authorities?</i></p>
 
-<a name="bandwidth-history"></a><p><b><a href="#bandwidth-history">bandwidth history:</a></b> traffic volume in incoming and/or outgoing direction that a <a href="#relay">relay</a> reports to have handled on behalf of <a href="#client">clients</a>.
+<a name="bandwidth-history"></a><p><b><a href="#bandwidth-history">bandwidth history:</a></b> the volume of incoming and/or outgoing traffic that a <a href="#relay">relay</a> claims to have handled on behalf of <a href="#client">clients</a>. This value is self-reported and may not correspond to observations by the <a href="#directory-authority">directory authorities</a>.
 <br><i>--is it clear enough that bandwidth histories are self-reported by relays and not verified by directory authorities?</i></p>
 
-<a name="bridge"></a><p><b><a href="#bridge">bridge:</a></b> non-publicly listed <a href="#relay">relay</a> that provides access for blocked <a href="#client">clients</a>, often in combination with <a href="#pluggable-transport">pluggable transports</a>, and that registers itself at the <a href="#bridge-authority">bridge authority</a>.
+<a name="bridge"></a><p><b><a href="#bridge">bridge:</a></b> a <a href="#relay">relay</a> whose existence is non-public and which can therefore provide access for blocked <a href="#client">clients</a>, often in combination with <a href="#pluggable-transport">pluggable transports</a>. Bridges usually register themselves with the <a href="#bridge-authority">bridge authority</a>.
 
-<a name="bridge-authority"></a><p><b><a href="#bridge-authority">bridge authority:</a></b> special-purpose <a href="#relay">relay</a> that maintains a list of bridges as input for external bridge distribution mechanisms (e.g., <a href="https://bridges.torproject.org/">BridgeDB</a>).</p>
+<a name="bridge-authority"></a><p><b><a href="#bridge-authority">bridge authority:</a></b> a special-purpose <a href="#relay">relay</a> that maintains a list of bridges as input for external bridge distribution mechanisms (e.g., <a href="https://bridges.torproject.org/">BridgeDB</a>).</p>
 
-<a name="circuit"></a><p><b><a href="#circuit">circuit:</a></b> path through the Tor network built by <a href="#client">clients</a> consisting of at most one <a href="#bridge">bridge</a> and at least one <a href="#relay">relay</a>.</p>
+<a name="circuit"></a><p><b><a href="#circuit">circuit:</a></b> a path through the Tor network built by <a href="#client">clients</a> consisting of at most one <a href="#bridge">bridge</a> and at least one <a href="#relay">relay</a>.</p>
 
-<a name="client"></a><p><b><a href="#client">client:</a></b> node in the Tor network running on behalf of typically one user to route application connections over a series of <a href="#relay">relays</a>.</p>
+<a name="client"></a><p><b><a href="#client">client:</a></b> a node in the Tor network, typically running on behalf of one user, that routes application connections over a series of <a href="#relay">relays</a>.</p>
 
-<a name="consensus-weight"></a><p><b><a href="#consensus-weight">consensus weight:</a></b> value assigned to a <a href="#relay">relay</a> that is based on bandwidth observed by the relay and bandwidth measured by the <a href="#directory-authority">directory authorities</a>, included in the hourly published consensus document, and used by <a href="#client">clients</a> to select relays for their <a href="#circuit">circuits</a>.
+<a name="consensus-weight"></a><p><b><a href="#consensus-weight">consensus weight:</a></b> a value assigned to a <a href="#relay">relay</a> that is measured by the <a href="#directory-authority">directory authorities</a>, included in the hourly published consensus document, and used by <a href="#client">clients</a> to select relays for their <a href="#circuit">circuits</a>.
 
-<a name="directory-authority"></a><p><b><a href="#directory-authority">directory authority:</a></b> special-purpose <a href="#relay">relay</a> that maintains a list of currently running relays and periodically publishes a consensus document together with the other directory authorities.</p>
+<a name="directory-authority"></a><p><b><a href="#directory-authority">directory authority:</a></b> a special-purpose <a href="#relay">relay</a> that maintains a list of currently-running relays and periodically publishes a consensus document together with the other directory authorities.</p>
 
-<a name="directory-mirror"></a><p><b><a href="#directory-mirror">directory mirror:</a></b> <a href="#relay">relay</a> that provides a recent copy of directory information to clients to reduce load on <a href="#directory-authority">directory authorities</a>.</p>
+<a name="directory-mirror"></a><p><b><a href="#directory-mirror">directory mirror:</a></b> a <a href="#relay">relay</a> that provides a recent copy of directory information to clients, in order to reduce the load on <a href="#directory-authority">directory authorities</a>.</p>
 
-<a name="hidden-service"></a><p><b><a href="#hidden-service">hidden service:</a></b> location-hidden service that is only accessible via the Tor network.</p>
+<a name="hidden-service"></a><p><b><a href="#hidden-service">hidden service:</a></b> a location-hidden service (for example, a website or instant-messaging server) that is only accessible via the Tor network.</p>
 
-<a name="pluggable-transport"></a><p><b><a href="#pluggable-transport">pluggable transport:</a></b> alternative transport protocol provided by <a href="#bridge">bridges</a> and used by <a href="#client">clients</a> to circumvent transport-level blockings.</p>
+<a name="pluggable-transport"></a><p><b><a href="#pluggable-transport">pluggable transport:</a></b> an alternative transport protocol provided by <a href="#bridge">bridges</a> and used by <a href="#client">clients</a> to circumvent transport-level blockings (for example, by ISPs or governments).</p>
 
-<a name="relay"></a><p><b><a href="#relay">relay:</a></b> publicly listed node in the Tor network that forwards traffic on behalf of <a href="#client">clients</a> and that registers itself at the <a href="#directory-authority">directory authorities</a>.
+<a name="relay"></a><p><b><a href="#relay">relay:</a></b> a publicly-listed node in the Tor network that forwards traffic on behalf of <a href="#client">clients</a>, and that registers itself with the <a href="#directory-authority">directory authorities</a>.
 
-<a name="relay-flag"></a><p><b><a href="#relay-flag">relay flag:</a></b> special (dis-)qualification of <a href="#relay">relays</a> for circuit positions (e.g., "Guard", "Exit", "BadExit"), circuit properties (e.g., "Fast", "Stable"), or roles (e.g., "Authority", "HSDir"), as assigned by the <a href="#directory-authority">directory authorities</a> and further defined in the <a href="https://gitweb.torproject.org/torspec.git/blob/HEAD:/dir-spec.txt">directory protocol specification</a>.</p>
+<a name="relay-flag"></a><p><b><a href="#relay-flag">relay flag:</a></b> a special (dis-)qualification of <a href="#relay">relays</a> for circuit positions (e.g., "Guard", "Exit", "BadExit"), circuit properties (e.g., "Fast", "Stable"), or roles (e.g., "Authority", "HSDir"), as assigned by the <a href="#directory-authority">directory authorities</a> and further defined in the <a href="https://gitweb.torproject.org/torspec.git/blob/HEAD:/dir-spec.txt">directory protocol specification</a>.</p>
 
 <h3>Omitted terms</h3>
 
@@ -61,8 +61,8 @@
 
 <h3>Graph: Relays with Exit, Fast, Guard, Stable, and HSDir flags</h3>
 
-<p>The following graphs shows the number of running <a href="#relay">relays</a> that got certain <a href="#relay-flag">flags</a> assigned by the <a href="#directory-authority">directory authorities</a>.
-These flags indicate that a relay should be prefered for either guard ("Guard") or exit position ("Exit"), that a relay is suitable for high-bandwidth ("Fast") or long-lived circuits ("Stable"), or that a relay is considered a hidden service directory ("HSDir").</p>
+<p>The following graphs shows the number of running <a href="#relay">relays</a> that have had certain <a href="#relay-flag">flags</a> assigned by the <a href="#directory-authority">directory authorities</a>.
+These flags indicate that a relay should be preferred for either guard ("Guard") or exit positions ("Exit"), that a relay is suitable for high-bandwidth ("Fast") or long-lived circuits ("Stable"), or that a relay is considered a hidden service directory ("HSDir").</p>
 
 <img src="https://metrics.torproject.org/relayflags.png">
 
@@ -70,7 +70,7 @@
 
 <p>The following graph shows the number of running <a href="#relay">relays</a> by tor software version.
 Relays report their tor software version when they announce themselves in the network.
-More details on when these versions have been declared stable or unstable can be found on the <a href="https://www.torproject.org/download/download.html.en">download page</a> and in the <a href="https://gitweb.torproject.org/tor.git/blob/HEAD:/ChangeLog">changes file</a>.</p>
+More details on when these versions were declared stable or unstable can be found on the <a href="https://www.torproject.org/download/download.html.en">download page</a> and in the <a href="https://gitweb.torproject.org/tor.git/blob/HEAD:/ChangeLog">changes file</a>.</p>
 
 <img src="https://metrics.torproject.org/versions.png">
 
@@ -91,47 +91,47 @@
 <h3>Data: Number of relays and bridges</h3>
 
 <p>The following data file contains the number of running <a href="#relay">relays</a> and <a href="#bridge">bridges</a> in the network.
-Statistics include subsets of relays or bridges by <a href="glossary#relay-flag">relay flag</a> (only relays), country code (only relays and only until February 2013), tor software version (only relays), operating system (only relays), and whether or not being run in the EC2 cloud (only bridges).
-The data file contains daily averages (means) of relay and bridge numbers.</p>
+Statistics include subsets of relays or bridges by <a href="glossary#relay-flag">relay flag</a> (relays only), country code (relays only, and only until February 2013), tor software version (relays only), operating system (relays only), and by whether or not they are running in the EC2 cloud (bridges only).
+The data file contains daily (mean) averages of relay and bridge numbers.</p>
 
 <h2>Bandwidth</h2>
 
 <h3>Graph: Total relay bandwidth in the network</h3>
 
-<p>The following graph shows total <a href="#advertised-bandwidth">advertised</a> and <a href="#bandwidth-history">consumed bandwidth</a> of all <a href="#relay">relays</a> in the network.</p>
+<p>The following graph shows the total <a href="#advertised-bandwidth">advertised</a> and <a href="#bandwidth-history">consumed bandwidth</a> of all <a href="#relay">relays</a> in the network.</p>
 
 <img src="https://metrics.torproject.org/bandwidth.png">
 
 <h3>Graph: Relay bandwidth by Exit and/or Guard flags</h3>
 
-<p>The following graph shows <a href="#bandwidth-history">consumed bandwidth</a> of relays, subdivided into four distinct subsets by assigned "Exit" and/or "Guard" <a href="#relay-flag">flags</a>.</p>
+<p>The following graph shows the <a href="#bandwidth-history">consumed bandwidth</a> reported by relays, subdivided into four distinct subsets by assigned "Exit" and/or "Guard" <a href="#relay-flag">flags</a>.</p>
 
 <img src="https://metrics.torproject.org/bwhist-flags.png">
 
 <h3>Graph: Advertised bandwidth and bandwidth history by relay flags</h3>
 
 The following graph shows <a href="#advertised-bandwidth">advertised</a> and <a href="#bandwidth-history">consumed bandwidth</a> of relays with either "Exit" or "Guard" <a href="#relay-flag">flags</a> assigned by the directory authorities.
-These sets are not distinct, because a relay that has both the "Exit" and "Guard" flag assigned will be included in both sets.</p>
+These sets are not distinct, because a relay that has both the "Exit" and "Guard" flags assigned will be included in both sets.</p>
 
 <img src="https://metrics.torproject.org/bandwidth-flags.png">
 
 <h3>Graph: Number of bytes spent on answering directory requests</h3>
 
-<p>The following graph shows the portion of <a href="#bandwidth-history">consumed bandwidth</a> that <a href="#directory-authority">directory authorities</a> and <a href="#directory-mirror">mirrors</a> spent on answering directory requests.
-Not all directories report these statistics, so that the graph shows an estimation of total consumed bandwidth as it would be observed if all directories reported these statistics.</p>
+<p>The following graph shows the portion of <a href="#bandwidth-history">consumed bandwidth</a> that <a href="#relay">relays</a> have spent on answering directory requests.
+Not all relays report these statistics, so the graph shows an estimation of total consumed bandwidth as it would be observed if all relays reported these statistics.</p>
 
 <img src="https://metrics.torproject.org/dirbytes.png">
 
 <h3>Data: Bandwidth provided and consumed by relays</h3>
 
 <p>The following data file contains statistics on <a href="#advertised-bandwidth">advertised</a> and <a href="#bandwidth-history">consumed bandwidth</a> of <a href="#relay">relays</a> in the network.
-Statistics on advertised bandwidth include any kind of traffic handled by a relay, whereas statistics on consumed bandwidth are available for all traffic together and specifically for serving directory data.
+Statistics on advertised bandwidth include any kind of traffic handled by a relay, whereas statistics on consumed bandwidth are available either for all traffic combined, or specifically for directory traffic.
 Some of the statistics are available for subsets of relays that have the "Exit" and/or the "Guard" <a href="#relay-flag">flag</a>.
-The data file contains daily averages (means) of bandwidth numbers.</p>
+The data file contains daily (mean) averages of bandwidth numbers.</p>
 
 <h3>Graph: Advertised bandwidth distribution</h3>
 
-<p>The following graph shows the distribution of <a href="glossary#advertised-bandwidth">advertised bandwidth</a> of relays in the network.
+<p>The following graph shows the distribution of the <a href="glossary#advertised-bandwidth">advertised bandwidth</a> of relays in the network.
 Each percentile represents the advertised bandwidth that a given percentage of relays does not exceed (and that in turn the remaining relays either match or exceed).
 For example, 99% of relays advertise at most the bandwidth value shown in the 99th percentile line (and the remaining 1% advertise at least that amount).</p>
 
@@ -139,7 +139,7 @@
 
 <h3>Graph: Advertised bandwidth of n-th fastest relays</h3>
 
-<p>The following graph shows the <a href="#advertised-bandwidth">advertised bandwidth</a> of the n-th fastest relays in the network.</p>
+<p>The following graph shows the <a href="#advertised-bandwidth">advertised bandwidth</a> of the n-th fastest relays in the network - please configure the value of n below the graph to obtain the statistics you need.</p>
 
 <img src="https://metrics.torproject.org/advbwdist-relay.png">
 
@@ -148,14 +148,14 @@
 <p>The following data file contains statistics on the distribution of <a href="#advertised-bandwidth">advertised bandwidth</a> of relays in the network.
 These statistics include advertised bandwidth percentiles and advertised bandwidth values of the n-th fastest relays.
 All values are obtained from advertised bandwidths of running relays in a network status consensus.
-The data file contains daily averages (medians) of percentiles and n-th largest values.</p>
+The data file contains daily (median) averages of percentiles and n-th largest values.</p>
 
 <h2>Diversity</h2>
 
 <h3>Graph: Network bubble graphs</h3>
 
 <p>The following graph visualizes diversity of currently running <a href="#relay">relays</a> in terms of their probability to be selected for <a href="#circuit">circuits</a>.
-Fast relays with at least 100 Mbit/s bandwidth capacity that have high probability of being selected for circuits are represented by an onion, smaller relays are shown as a simple dot, and the slowest relays which are almost never selected for circuits are omitted entirely.
+Fast relays with at least 100 Mbit/s bandwidth capacity, and which therefore have a high probability of being selected for circuits, are represented by an onion; smaller relays are shown as a simple dot; and the slowest relays, which are almost never selected for circuits, are omitted entirely.
 Graphs in the "all relays" category use a relay's <a href="#consensus-weight">consensus weight</a> as probability, whereas graphs in the "exits only" category use a value derived from a relay's consensus weight that resembles the probability of selecting that relay as exit node.
 All graphs support grouping relays by same autonomous system, contact information, country, or network family.</p>
 
@@ -165,22 +165,22 @@
 
 <h3>Graph: Direct users by country</h3>
 
-<p>The following graph shows the estimated number of directly connecting <a href="#client">clients</a>, that is, excluding clients connecting via <a href="#bridge">bridges</a>.
+<p>The following graph shows the estimated number of directly-connecting <a href="#client">clients</a>; that is, it excludes clients connecting via <a href="#bridge">bridges</a>.
 These estimates are derived from the number of directory requests counted on <a href="#directory-authority">directory authorities</a> and <a href="#directory-mirror">mirrors</a>.
 Relays resolve client IP addresses to country codes, so that graphs are available for most countries.
-Further, it's possible to display indications of censorship events as obtained from an anomaly-based censorship-detection system (for more details, see this <a href="https://research.torproject.org/techreports/detector-2011-09-09.pdf">technical report</a>).</p>
+Furthermore, it's possible to display indications of censorship events as obtained from an anomaly-based censorship-detection system (for more details, see this <a href="https://research.torproject.org/techreports/detector-2011-09-09.pdf">technical report</a>).</p>
 
 <img src="https://metrics.torproject.org/userstats-relay-country.png">
 
 <h3>Table: Top-10 countries by directly connecting users</h3>
 
-<p>The following table shows the top-10 countries by estimated number of directly connecting <a href="#client">clients</a>.
+<p>The following table shows the top-10 countries by estimated number of directly-connecting <a href="#client">clients</a>.
 These numbers are derived from directory requests counted on <a href="#directory-authority">directory authorities</a> and <a href="#directory-mirror">mirrors</a>.
 Relays resolve client IP addresses to country codes, so that numbers are available for most countries.</p>
 
 <h3>Table: Top-10 countries by possible censorship events</h3>
 
-<p>The following table shows the top-10 countries by possible censorship events as obtained from an anomaly-based censorship-detection system (for more details, see this <a href="https://research.torproject.org/techreports/detector-2011-09-09.pdf">technical report</a>).</p>
+<p>The following table shows the top-10 countries by possible censorship events, as obtained from an anomaly-based censorship-detection system (for more details, see this <a href="https://research.torproject.org/techreports/detector-2011-09-09.pdf">technical report</a>).</p>
 
 <h3>Graph: Bridge users by country</h3>
 
@@ -223,16 +223,16 @@
 <p>The following data file contains estimates on the number of <a href="#client">clients</a> in the network.
 These numbers are derived from directory requests counted on <a href="#directory-authority">directory authorities</a>, <a href="#directory-mirror">directory mirrors</a>, and <a href="#bridge">bridges</a>.
 Statistics are available for clients connecting directly relays and clients connecting via bridges.
-There are statistics available by country (directly connecting clients and clients connecting via bridges), by transport protocol (only clients connecting via bridges), and by IP version (only clients connecting via bridges).
+There are statistics available by country (for both directly-connecting clients and clients connecting via bridges), by transport protocol (only for clients connecting via bridges), and by IP version (only for clients connecting via bridges).
 
-Statistics further include predicted client numbers from past observations which can be used to detect censorship events.</p>
+Statistics also include predicted client numbers from past observations, which can be used to detect censorship events.</p>
 
 <h2>Performance</h2>
 
 <h3>Graph: Time to download files over Tor</h3>
 
-<p>The following graph shows the overall performance of downloading static files of different sizes over Tor.
-The graph shows the range of measurements from first to third quartile and highlights the median.
+<p>The following graph shows overall performance when downloading static files of different sizes over Tor.
+The graph shows the range of measurements from first to third quartile, and highlights the median.
 The slowest and fastest quarter of measurements are omitted from the graph.</p>
 
 <img src="https://metrics.torproject.org/torperf.png">
@@ -247,8 +247,8 @@
 
 <h3>Data: Performance of downloading static files over Tor</h3>
 
-<p>The following data file contains aggregate statistics on the performance of downloading static files of different sizes over Tor.
-These statistics are generated by the <a href="https://gitweb.torproject.org/torperf.git">Torperf</a> tool that periodically fetches static files over Tor and records several timestamps in the process.
+<p>The following data file contains aggregate statistics on performance when downloading static files of different sizes over Tor.
+These statistics are generated by the <a href="https://gitweb.torproject.org/torperf.git">Torperf</a> tool, which periodically fetches static files over Tor and records several timestamps in the process.
 The data file contains daily medians and quartiles as well as total numbers of requests, timeouts, and failures.</p>
 
 <h3>Graph: Fraction of connections used uni-/bidirectionally</h3>
@@ -272,7 +272,7 @@
 If so, they classify a connection as "mostly reading" or "mostly writing", respectively.
 All other connections are classified as "both reading and writing".
 After classifying connections, read and write counters are reset for the next 10-second interval.
-The data file contains the absolute number of 10-second intervals per relay aggregated over 24-hour periods.</p>
+The data file contains the absolute number of 10-second intervals per relay, aggregated over 24-hour periods.</p>
 
 </body>
 </html>